/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "clock.h"

unsigned char ss	= 0;
unsigned char mm	= 21;
unsigned char hh	= 22;

#if USE_CLOCK

//############################################################################
//Diese Routine addiert 1Sekunde wenn Timer Interrupt ausgelst wird 
SIGNAL (SIG_OVERFLOW1)
//############################################################################
{
	TCNT1 = 65535 - (SYSCLK / 1024);
	ss++;
	if (ss == 60)
		{
		ss = 0;
		mm++;
		if (mm == 60)
			{
			mm = 0;
			hh++;
			if (hh == 24)
				{
				hh = 0;
				}
			}
		
		}
}


//############################################################################
//Diese Routine startet und inizialisiert den Timer
void Start_Clock (void)
//############################################################################
{
	//Interrupt for the Clock enable
	timer_enable_int(_BV(TOIE1));
	TCCR1B |= (1<<CS10 | 0<<CS11 | 1<<CS12); //Prescaler = 1024 
	return;
}

#endif //#if USE_CLOCK

