/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

Bei Fragen und Verbesserungen wendet euch per EMail an

mail@ulrichradig.de

oder im Forum meiner Web Page : www.ulrichradig.de


Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#include "main.h"

//Die beiden hier knnte man vieleicht doch besser ins RAM legen. Holgi
//MAC Addresse des Web Servers
const unsigned char mymac[] = {30,10,43,43,45,77};

//IP Addresse des Web Servers
const unsigned char MYIP[] = {192,168,0,101};



uint8_t gSensorIDs[MAXSENSORS][OW_ROMCODE_SIZE];

uint8_t search_sensors(void)
{
	uint8_t i;
	uint8_t id[OW_ROMCODE_SIZE];
	uint8_t diff, nSensors;
	
	printf( "\r\nScanning Bus for DS18X20\r\n" );
	
	nSensors = 0;
	
	for( diff = OW_SEARCH_FIRST; 
		diff != OW_LAST_DEVICE && nSensors < MAXSENSORS ; )
	{
		DS18X20_find_sensor( &diff, &id[0] );
		
		if( diff == OW_PRESENCE_ERR ) {
			printf( "No Sensor found\r\n" );
			break;
		}
		
		if( diff == OW_DATA_ERR ) {
			printf( "Bus Error\r\n" );
			break;
		}
		
		for (i=0;i<OW_ROMCODE_SIZE;i++)
			gSensorIDs[nSensors][i]=id[i];
		
		nSensors++;
	}
	
	return nSensors;
}



//############################################################################
//Hauptprogramm
int main (void)
//############################################################################
{
	UART_Init();
	// DS1820
	uint8_t nSensors, i;
	uint8_t subzero, cel, cel_frac_bits;
	
	
	#ifndef OW_ONE_BUS
	ow_set_bus(&PIND,&PORTD,&DDRD,PD7);
	#endif
	nSensors = search_sensors();
	
	// DS1820
	//Grundinizialisierung der Netzwerkkarte
	Init_Realtek_Network_Card();

	printf ("Card Init: %d \n",ReadRTL(0));
	//Ausgabe meiner MAC Adresse auf Serieller Schnittstelle
	printf ("\nMy Mac: %x.%x.%x.%x.%x.%x\n",mymac[0],mymac[1],mymac[2]
										   ,mymac[3],mymac[4],mymac[5]);

	//Ausgabe meiner IP Adresse auf Serieller Schnittstelle
	printf ("My IP : %d.%d.%d.%d\n\n",MYIP[0],MYIP[1],MYIP[2],MYIP[3]);	

	//Globale Interrupts Einschalten
	sei ();
	
	//Interrupt 4 Mega103/128 Interrupt 0 bei Mega32 
	//soll auslsen bei ansteigender Flanke

	#if defined (__AVR_ATmega32__)	
		MCUCR=0x01;
	#endif	
	
	#if defined (__AVR_ATmega103__)
		EICR = 0x03;
	#endif
	
	#if defined (__AVR_ATmega128__)
		EICR = 0x03;
	#endif

	//Interrupt 4 oder 0 Einschalten (fr die Netzwerkkarte)
	#if defined (__AVR_ATmega103__)
		enable_external_int (1<<INT4);
	#endif
	
	#if defined (__AVR_ATmega128__)
		enable_external_int (1<<INT4);
	#endif
	
	#if defined (__AVR_ATmega32__)	
		enable_external_int (1<<INT0);
	#endif	

	#if USE_CLOCK
		Start_Clock();
	#endif

	//startet die Network Card
	WriteRTL (CR , 0x22);

	//Hauptprogramm luft stndig in einer schleife und macht nichts
	while (1)
		{
			for ( i=nSensors; i>0; i-- ) {
			if ( DS18X20_start_meas( DS18X20_POWER_PARASITE, 
				&gSensorIDs[i-1][0] ) == DS18X20_OK ) {
				delay_ms(DS18B20_TCONV_12BIT);
				//uart_puts_P("Sensor# ");
				//uart_puti((int) i);
				//uart_puts_P(" = ");
				if ( DS18X20_read_meas( &gSensorIDs[i-1][0], &subzero,
						&cel, &cel_frac_bits) == DS18X20_OK ) {
					//uart_put_temp(subzero, cel, cel_frac_bits);
					printf("%d\n",cel);
					temperature = cel;
					Subzero = subzero;
				}
				//else uart_puts_P("CRC Error (lost connection?)");
				//uart_puts_P("\r\n");
			}
			//else uart_puts_P("Start meas. failed (short circuit?)");
		}
		}
return (1);
}

