/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _RTL_8019_H
 #define _RTL_8019_H

//Prototype
extern void WriteRTL (unsigned char,unsigned char);
extern unsigned char ReadRTL (unsigned char);
extern void Init_Realtek_Network_Card (void);
extern void Write_Ethernet_Frame (char *,unsigned int);
extern void Read_Ethernet_Frame (char *,unsigned int *);

#define nop()  __asm__ __volatile__ ("nop" ::)

#define RTL_WR_OFF() cbi(ADDR_PORT_RLT,WRITE_PIN);
#define RTL_WR_ON() sbi(ADDR_PORT_RLT,WRITE_PIN);

#define RTL_RD_OFF() cbi(ADDR_PORT_RLT,READ_PIN);
#define RTL_RD_ON()  sbi(ADDR_PORT_RLT,READ_PIN);

#define RTL_RESET_OFF() cbi(ADDR_PORT_RLT,RESET_PIN);


//Ethernet Card Ports
#define DATA_CTRL_RLT  			DDRA
#define DATA_ADDR_RLT			DDRC	//Fr ATMega128/32 wird bei ATMega102 nicht ben.
#define ADDR_PORT_RLT  			PORTC
#define DATA_PORT_RLT_WRITE  	PORTA
#define DATA_PORT_RLT_READ 		PINA	//Read
#define WRITE_PIN				6		//gibt den Pin an WriteIO Signal angeschlossen
#define READ_PIN				5		//gibt den Pin an ReadIO Signal angeschlossen
#define RESET_PIN				7		//gibt den Pin an Reset angeschlossen ist
#define INPUT					0x00	//setzt einen Port auf Input
#define OUTPUT					0xff	//setzt einen Port auf Output

//Realtek Netzwerkkarten Register
#define RTL_REG_OFFSET				96
#define CR					RTL_REG_OFFSET+0x00
#define PSTART					RTL_REG_OFFSET+0x01
#define PAR0					RTL_REG_OFFSET+0x01                                          
#define PSTOP					RTL_REG_OFFSET+0x02
#define BNRY					RTL_REG_OFFSET+0x03
#define TPSR					RTL_REG_OFFSET+0x04
#define TBCR0					RTL_REG_OFFSET+0x05
#define TBCR1					RTL_REG_OFFSET+0x06
#define ISR					RTL_REG_OFFSET+0x07
#define CURR					RTL_REG_OFFSET+0x07                                       
#define RSAR0					RTL_REG_OFFSET+0x08
#define CRDA0					RTL_REG_OFFSET+0x08
#define RSAR1					RTL_REG_OFFSET+0x09	
#define CRDAl					RTL_REG_OFFSET+0x09
#define RBCR0					RTL_REG_OFFSET+0x0A
#define RBCR1					RTL_REG_OFFSET+0x0B
#define RSR					RTL_REG_OFFSET+0x0C
#define RCR					RTL_REG_OFFSET+0x0C
#define TCR					RTL_REG_OFFSET+0x0D
#define CNTR0					RTL_REG_OFFSET+0x0D
#define DCR					RTL_REG_OFFSET+0x0E
#define CNTR1					RTL_REG_OFFSET+0x0E
#define IMR					RTL_REG_OFFSET+0x0F
#define CNTR2					RTL_REG_OFFSET+0x0F
#define RDMAPORT				RTL_REG_OFFSET+0x10
#define RSTPORT					RTL_REG_OFFSET+0x18
//RTL8019AS initial register Werte
#define RCRVAL					0x04
#define TCRVAL					0x00
#define DCRVAL					0x58
//PXR and OVW interrupt enabled
#define IMRVAL					0x11
#define TXSTART					0x40
#define RXSTART					0x46
#define RXSTOP					0x60
//RTL8019AS ISR Register Bits
#define RST						7
#define RDC						6
#define OVW						4
#define PRX						0

#endif // _RTL_8019_H


