/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "clock.h"

PROGMEM char telnet_OK[] = {"\0%END"};
PROGMEM char telnet_newline[] = {">%END"};
PROGMEM char telnet_end[] = {"Good Bye!\r\n%END"};
PROGMEM char telnet_welcome[] = {"Willkommen auf dem Telnetserver\r\n>%END"};
unsigned char cmd[20];
unsigned char cmd_Counter = 0;

//############################################################################
//
void telnet (char* buffer,int *bufferlen)
//############################################################################
{	
	//Verwaltung Stackpointer
	int a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack (buffer,bufferlen,&a)== 1)
		{
		return;//keine Daten fr Anwendung
		}
	
	//Antwort Telnet Server Vorhanden 
	if ((buffer[TCP_HDRFLAGS+1]&ACK_FLAG) > 0 && TCP_Socket_Status[a] == 1)
			{
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);		
			//Setzen des Ack Flag
			buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
			//Telnet Server Antwort Packet
			tcp_add_data (telnet_welcome,buffer,bufferlen);	
			//Erzeugt ein TCP Packet 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP Packet 
			Write_Ethernet_Frame (buffer,*bufferlen);
			TCP_Socket_Status[a] = 2;
			return;
			}
			
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && TCP_Socket_Status[a] == 2)
	{
		unsigned int result16;
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);	
		//Errechnet startpunkt der Daten im Tcp buffer
		//IP Headerlnge + TCP Headerlnge + Ethernetframe
		result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 
					((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;		
		//Ausgabe des empfangenen Zeichens
		cmd[cmd_Counter] = buffer[result16];
		cmd_Counter++;
		if (buffer[result16]==0x0d)
			{
			cmd_Counter = 0;
				int command;
						
				#if USE_CLOCK
					command = memcmp(&cmd[0],"time",4); //Commando zur Ausgabe der Zeit
					if ( command == 0) 
						{
						char string[40]= {"Time: "};
						char tmp[5];
							
						strcat (string,itoa(hh,tmp,10));
						strcat (string,":");
						strcat (string,itoa(mm,tmp,10));
						strcat (string,":");
						strcat (string,itoa(ss,tmp,10));
							
						strcat (string,"\r\n>");
						tcp_add_datastring (string,buffer,bufferlen);
						goto telnet_end;
						}		
					command = memcmp(&cmd[0],"set time",8); //Commando setzen der Zeit
					if ( command == 0) 
						{
						char string[40]= {"Time: "};
						char tmp[5];
									
						//auslesen der Stunden aus String
						tmp[0] = cmd[9];
						tmp[1] = cmd[10];
						tmp[2] = 0;
						hh = (atoi(tmp) & 0x00FF);
						//auslesen der Minuten aus String
						tmp[0] = cmd[12];
						tmp[1] = cmd[13];
						tmp[2] = 0;
						mm = (atoi(tmp) & 0x00FF);
						//auslesen der Sekunden aus String
						tmp[0] = cmd[15];
						tmp[1] = cmd[16];
						tmp[2] = 0;
						ss = (atoi(tmp) & 0x00FF);
									
						strcat (string,itoa(hh,tmp,10));
						strcat (string,":");
						strcat (string,itoa(mm,tmp,10));
						strcat (string,":");
						strcat (string,itoa(ss,tmp,10));
										
						strcat (string,"\r\n>");
						tcp_add_datastring (string,buffer,bufferlen);
						goto telnet_end;
						}
				#endif
				command = memcmp(&cmd[0],"quit",4); //Commando setzen der Zeit
				if ( command == 0) 
					{
					tcp_add_data (telnet_end,buffer,bufferlen);
					TCP_Socket_Status[a] = 3;
					goto telnet_end;
					}
				tcp_add_data (telnet_newline,buffer,bufferlen);
				goto telnet_end;
			};			
			tcp_add_data (telnet_OK,buffer,bufferlen);
				
			telnet_end:
			buffer[TCP_HDRFLAGS+1] = ACK_FLAG;
			//Erzeugt ein TCP buffer 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP buffer 
			Write_Ethernet_Frame (buffer,*bufferlen);
	}
	
	return;
}
